Subject: Re: [PATCH 2/3] [VLAN]: Update iif when receiving via VLAN device

From: Ben Greear <[email-masked]>
Date: Fri, 30 Jun 2006 10:27:12 -0700

Thomas Graf wrote:
> * Thomas Graf <[email-masked]> 2006-06-30 18:32
> 
>>Anyways, I give up. Last time I've been running after you trying
>>to fix the many bugs you leave behind. Ever noticed that whenever
>>you add some new code it's someone else following up with tons of
>>small bugfix patches having a hard time trying to figure out the
>>actual intent. I'll just duplicate the code for my purpose, so
>>much easier.
> 
> 
> There you go, leaves ifb broken as-is, at least prevents it
> from crashing randomly when the input_dev disappears.
> 
> [NET]: Use interface index to keep input device information
> 
> Using the interface index instead of a direct reference
> allows a safe usage beyond the scope where an interface
> could disappear.
> 
> The old input_dev field was incorrectly made dependant
> on CONFIG_NET_CLS_ACT in skb_copy().
> 
> Signed-off-by: Thomas Graf <[email-masked]>

> ===================================================================
> --- net-2.6.git.orig/drivers/net/ifb.c
> +++ net-2.6.git/drivers/net/ifb.c
> @@ -158,19 +158,23 @@ static int ifb_xmit(struct sk_buff *skb,
>  	stats->tx_packets++;
>  	stats->tx_bytes+=skb->len;
>  
> -	if (!from || !skb->input_dev) {
> +	if (!from || !skb->iif) {

Since iif of 0 is valid (afaik), this check is now bogus, eh?

Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com